void scribe(String S) {fill(black); text(S,20,20); noFill();}
void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}
void scribe(String S, int i, int j) {fill(black); text(S,width-10*j,20+i*20); noFill();}

void mousePressed() {myMousePressed();}
void mouseReleased() {myMouseReleased();} 

void keyPressed() { 
  if (key==' ') showHelpText=!showHelpText ; 
  if (key=='?') printIt=true;  // toggle debug mode
  if  (47<int(key)) if (int(key)<57)  { int n=int(key)-48; mySelected(n);}  // accepts input in [0,9]

  if(key=='a') animate=!animate;    
  if(key=='l') linear=!linear;  
  if(key=='g') geometric=!geometric;  
  if(key=='f') myFilter();  
  if(key=='R') myRefine();  
  if(key=='S') myResample();  
//  if(key=='s') myScale();  
//  if(key=='r') myRotate();  
//  if(key=='t') myTranslate();  

  if (key=='W') mySave(); 
  if (key=='L') myLoad(); 
  if (key=='I') myReset();
  if (key=='X') picture(); 
  };     

void showHelp() {
    fill(dblue); pushMatrix(); translate(20,20);
     text("Polyloop manipulation with Jarek Rossignac's Geometry Sandbox",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("First click in the window to activate it ",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("Press '1' through '9' to ...",0,0); translate(0,20);
     text("Press 'I' to reset, 'W' to write points to file, and 'L' to load points",0,0); translate(0,20);
     text("To redraw the curve: press 'd' then click and drag the mouse",0,0); translate(0,20);
     text("Press 'S' to subdivide, 'f' to filter, and 'R' to resample the curve ",0,0); translate(0,20);
     text("Press 's' to scale, 'r' to rotate, and 't' to stranslate move the curve ",0,0); translate(0,20);
     text("Press 'd', click and drag the mouse to draw a new curve",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("Press 'X' top snap a picture (when running Processing, not in browser)",0,0); translate(0,20);
     text("'?' print debugging stuff (when running Processing, not in browser)   ",0,0); translate(0,20);
     popMatrix(); noFill();
   }
     
